#! /usr/bin/env python3
# -*- coding: utf-8 -*-

#	Copyright 2013, Marten de Vries
#
#	This file is part of OpenTeacher.
#
#	OpenTeacher is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, either version 3 of the License, or
#	(at your option) any later version.
#
#	OpenTeacher is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with OpenTeacher.  If not, see <http://www.gnu.org/licenses/>.

import urllib.request
import io
import logging

logger = logging.getLogger(__name__)

class MockOpener:
	def addheaders(self, headers):
		pass

	def open(self, request):
		if request.get_method() == "HEAD":
			return io.BytesIO()

		if request.get_full_url() == "http://www.wrts.nl/api/lists":
			return io.BytesIO(b'<?xml version="1.0" encoding="UTF-8"?><list-index />')

class TestUrllibMockModule:
	def __init__(self, moduleManager, *args, **kwargs):
		super().__init__(*args, **kwargs)
		self._mm = moduleManager

		self.priorities = {
			"test-suite": 0,
			"default": -1,
		}

	def _mockedUrlopen(self, url):
		logger.debug("url: %s" % url)
		if url.startswith("http://www.studystack.com/servlet/categoryListJson"):
			result = b"[]"
		elif url.startswith("http://vocatrain.com/api/select_categories.php") or url.startswith("http://woordjesleren.nl/api/select_categories.php"):
			result = b'<?xml version="1.0" encoding="UTF-8"?><woordjesleren version="1"><categories></categories></woordjesleren>'
		logger.debug("response: %s" % result)

		return io.BytesIO(result)

	def _mockedBuildOpener(self):
		return MockOpener()

	def enable(self):
		self._defaultUrlopen = urllib.request.urlopen
		self._defaultBuildOpener = urllib.request.build_opener

		urllib.request.urlopen = self._mockedUrlopen
		urllib.request.build_opener = self._mockedBuildOpener

		self.active = True

	def disable(self):
		self.active = False

		urllib.request.urlopen = self._defaultUrlopen
		urllib.request.build_opener = self._defaultBuildOpener

		del self._defaultUrlopen
		del self._defaultBuildOpener

def init(moduleManager):
	return TestUrllibMockModule(moduleManager)
